Attribute VB_Name = "modASM"
Option Explicit

Public Function EXE2ASM( _
    fsc As String, _
    Optional cnt As Long = 4, _
    Optional delInt3 As Boolean = True) As Boolean
    
    Dim tmp     As String * 22
    Dim txt     As String
    Dim ret     As String
    Dim gmt     As Date
    Dim I1      As Long
    Dim asm()   As Long
    
    If EXE2ARR(fsc, asm, gmt, delInt3) Then
        I1 = Len(Format(UBound(asm)))
        ret = "    Static asm(" & UBound(asm) & ") as Long" & _
              "    ' " & fsc & " " & gmt & " (GMT)@@" & _
              "    If asm(0) = 0 Then@"

        For I1 = 0 To UBound(asm)
            If (I1 Mod cnt) = 0 Then
                ret = ret & Mid$("@        ", IIf(I1, 1, 2))
            End If
            
            txt = Hex(asm(I1))
            If (Len(txt) = 4) And (Asc(txt) > 55) Then txt = txt & "&"
            
            tmp = "asm(" & I1 & ")=&H" & txt & _
                  IIf(I1 < UBound(asm) And _
                     (I1 Mod cnt) <> cnt - 1, ":", "")
            ret = ret & tmp
        Next
        
        ret = ret & "@    End If@"
        
        Clipboard.Clear
        Clipboard.SetText Replace(ret, "@", vbCrLf)
        Debug.Print "copied to clipboard"
        EXE2ASM = True
    End If
End Function

Public Function EXE2ARR( _
    fsc As String, _
    arr() As Long, _
    Optional gmt As Date, _
    Optional delInt3 As Boolean = False) As Boolean
    
    Dim FNr          As Long
    Dim tmp          As Long
    Dim lng(0 To 71) As Long
    
    On Error Resume Next
    
    FNr = FreeFile
    Open fsc For Binary Access Read As #FNr
    If Err = 0 Then Get #FNr, , lng
    
    If Err Then
        MsgBox Error(Err)
        
    ElseIf (lng(0) And &HFFFF&) <> &H5A4D Then
        MsgBox "not an executable file"

    ElseIf lng(15) = 0 Then
        MsgBox "not a windows executable"

    Else
        tmp = lng(15) + 1
        Get #FNr, tmp, lng
        
        If Seek(FNr) < tmp + 288 Then
            MsgBox "invalid file format"
            
        ElseIf lng(0) <> &H4550 Or (lng(1) And &HFFFF&) <> &H14C Then
            MsgBox "this function supports only PE-files"
            
        ElseIf lng(1) = &H14C Then
            MsgBox "file does not include any section"
            
        ElseIf lng(1) > &H1014C Then
            MsgBox "file must not include more than one section"
            
        ElseIf lng(3) Or lng(4) Then
            MsgBox "symbol tables are not supported"
            
        ElseIf (lng(5) And &H20000) = 0 Then
            MsgBox "file must not include unresolved externals"
            
        ElseIf (lng(6) And &HFFFF&) <> &H10B Then
            MsgBox "corrupt file"
            
        ElseIf (lng(71) And &H20000020) <> &H20000020 Then
            MsgBox "only code sections are supported"
        
        ElseIf lng(7) = 0 Then
            MsgBox "code section is empty"
            
        ElseIf lng(70) Then
            MsgBox "code must not include relocatables"
            
        Else
            ReDim arr(((lng(64) + 3) And -4&) / 4 - 1)
            
            If Err Then
                MsgBox "could not re-dimension target array"
                
            Else
                Get #FNr, lng(67) + 1, arr
                 
                If delInt3 = True And (arr(0) And 255) = &HCC Then
                    arr(0) = (arr(0) And &HFFFFFF00) Or &H90
                End If
                
                tmp = 24# * 60 * 60
                lng(10) = lng(2) / tmp
                lng(11) = lng(2) - lng(10) * tmp
                lng(12) = DateSerial(1970, 1, 2)
                gmt = lng(10) + Sgn(lng(11)) + lng(11) / tmp + lng(12)
                EXE2ARR = True
            End If
        End If
    End If
    
    Close #FNr
End Function


